/*******************************************************************************
*  GPS.c | forf[^K[̃eXg                                         *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2014-09-10  ޒH[(ނ)  Create                            *
*  1.10    2016-06-16  ޒH[(ނ)  skSPIlibSPI_MODEύXɂC  *
*  2.00    2017-01-02  ޒH[(ނ)  CuXVɂC          *
*  2.10    2017-02-26  ޒH[(ނ)  skSDlib̕ύXɂC           *
* ============================================================================ *
*  PIC 18F25K22                                                                *
*  MPLAB X(V2.15)                                                              *
*  MPLAB(R) XC8 C Compiler Version 1.32                                        *
*******************************************************************************/
#include <xc.h>
#include <stdlib.h>
#include <string.h>
#include "skUARTlib.h"
#include "skSPIlib.h"
#include "skSDlib.h"
#include "skI2Clib.h"
#include "skI2CLCDlib.h"

#define _XTAL_FREQ            16000000  // delaypɕKv(NbN16MHzw)
// 萔̒`
#define SW_PIN_NO             6         // XCb`̐ڑsԍ
#define LED_PIN_NO            7         // LED̐ڑsԍ
#define SENTENCES_BUFLEN      82        // GPS̃bZ[Wf[^obt@̌
#define WRITE_INTERVAL        3         // ZeXފԊu̎w

//  vg^Cv̐錾
void Wait(unsigned int num) ;
void GPS_WriteMessage(void) ;
void GPS_StatusCheck(void) ;
int  GPS_GetMessageItem(char *dt1,char *dt2,int cnt) ;

// ʕϐ̐錾
int  RunFlag ;                          // 1:݋N  0:~
int  WriteIntervalCount ;               // ZeXފԊũJE^
char SentencesData[SENTENCES_BUFLEN] ;  // GPS̃ZeXf[^obt@
int  SentencesNum ;                     // GPS̃ZeX
int  GPS_Status ;                       // GPS̎M 0: 1:L
char Filename[13] = "G0000000.TXT" ;    // t@C = G[$GPRMC̓t][A-Z].TXT
// \̂̐錾Ə
struct {                                // MZeX̏ݏ
  char sentencesID[7] ;                 // $<TalkerID:2><ZeXID;3>
  int  WriteFlag ;                      // 1:  0:܂Ȃ
} WritingInfo[] = {                     // "$GPGGA""$GPRMC"͏ݕK{ł
  {"$GPGGA",1} ,{"$GPGSA",0} ,{"$GPRMC",1} ,
  {"$GPGLL",0} ,{"$GPGSV",0} ,{"$GPVTG",0} ,{"$GPZDA",0} ,
} ;


// RtBM[V̐ݒ(̋Lqɖݒ̓ftHglł̓)
// ONbN͎gpȂ(PRICLKEN_OFF)
// NbNS{ł͓삳Ȃ(PLLCFG_OFF)Fۯgp(INTIO67)
#pragma config PRICLKEN=OFF,PLLCFG=OFF,FOSC=INTIO67    // CONFIG1H
// dd~펞Ď@\ON(BOREN_NOSLP)FĎd(2.85V)ɐݒ
// dON65.6ms۸тJn(PWRTEN_ON)
#pragma config BOREN=NOSLP,BORV=285,PWRTEN=ON          // CONFIG2L
// ޯϰ(WDTEN_OFF)
#pragma config WDTEN=OFF                               // CONFIG2H
// OؾĐM͎gp޼ٓ(RE3)݂Ƃ(MCLRE_INTMCLR)
// IV[^肷̂҂ăVXeNbN(HFOFST_OFF)
#pragma config MCLRE=INTMCLR,HFOFST=OFF                // CONFIG3H
// dvO~O@\gpȂ(LVP_OFF)
#pragma config LVP=OFF                                 // CONFIG4L

// 荞݂̏
void interrupt InterFunction( void )
{
     // hQb֘Å荞(LCDŗp)
     InterI2C() ;
     // tr`qs֘Å荞(GPSŗp)
     InterUART() ;
}
// C̏
void main()
{
     int  i , ans ;
     char dt , x ;

     OSCCON = 0b01110010 ;    // NbNƂ(16MHz)
     INTCON2bits.RBPU = 0 ;   // vAbvs
     WPUB   = 0b00100110 ;    // RB1/RB2/RB5vAbv
     ANSELA = 0b00000000 ;    // AN0-4AiO͎gpȂAfW^I/OɊ
     ANSELB = 0b00000000 ;    // AN8-13AiO͎gpȂAfW^I/OɊ
     ANSELC = 0b00000000 ;    // AN14-19AiO͎gpȂAfW^I/OɊ
     TRISA  = 0b00000000 ;    // RA0-RA7Sďo͂ɐݒ
     TRISB  = 0b00100110 ;    // RB1(SCL)RB2(SDA)RB5(SW)͓́A͑SďóA1œ 0ŏo
     TRISC  = 0b10010000 ;    // RC4(SDI)RC7(RX)͓́A͑SďóA1œ 0ŏo
     PORTA  = 0b00000000 ;    // o̓s̏(SLOWɂ)
     PORTB  = 0b00000000 ;    // o̓s̏(SLOWɂ)
     PORTC  = 0b00000000 ;    // o̓s̏(SLOWɂ)

     // I2CʐM̃}X^[[hŏsAʐMx400KHz
     InitI2C_Master(1) ;
     // I2Cڑ^LCDW[̏
     // ICON OFF,RgXg(0-63),VDD=3.3VŎg,LCD8
     LCD_Init(LCD_NOT_ICON,40,LCD_VDD3V,8) ;
     LCD_Puts("StartGPS") ;
     // SPȈs(NbNɐ:HIGH NbNʑ:0@ʐMx:Fosc/4)
     SPI_Init(SPI_MODE3,SPI_CLOCK_DIV4,16) ;
     // MMC/SDC̏s
     ans = SD_Init() ;
     if (ans != 0) {
          // SDJ[hG[(J[h}H)
          LCD_SetCursor(0,1) ;
          LCD_Puts("ErrorSDC") ;
     }
     // USARTʐM̏s(4800bps)
     InitUART(0,0,207) ;
     // t@C̉ϕEEPROMɐݒ肷
     // OԒn"A"-"Z"̃f[^Ȃ炻̂܂܂ňႤȂ"A"ŏ
     x = eeprom_read(0) ;
     if (!(x >= 'A' && x <= 'Z')) eeprom_write(0,'A') ;
     // ϐނ̏s
     WriteIntervalCount = 0 ;
     SentencesNum = -1 ;
     GPS_Status   = 0 ;
     RunFlag      = 0 ;

     while(1) {
          // XCb`ON/OFFɂNԂς鏈
          if (PORTBbits.RB5 == LOW) {
               RunFlag = ~RunFlag ;
               LCD_SetCursor(0,0) ;
               if (RunFlag == 0) {
                    LCD_Puts("   OFF  ") ;
                    LCD_SetCursor(0,1) ;
                    LCD_Puts("        ") ;
                    PORTAbits.RA0 = LOW ;    // ~(LED OFF)
                    // Xe[^X͈U""ԂɂĒu
                    GPS_Status = 0 ;
               } else {
                    LCD_Puts("   ON   ") ;
                    PORTAbits.RA0 = HIGH ;   // N(LED ON)
                    // t@C̉ϕot@CɃZbg
                    x = eeprom_read(0) ;
                    Filename[7] = x ;
                    // t@C̉ϕ͎̕ɐi߂EEPROMɕۑ
                    x++ ;
                    if (x > 'Z') x = 'A' ;
                    eeprom_write(0,x) ;
                    // USARTMobt@NA
                    UART_Flush() ;
               }
               Wait(100) ;                   // `^Oh~(1s)
          }
          if (RunFlag == 0) continue ;       // ~Ȃȍ~Ȃ

          // ZeXf[^LȂ珈s
          ans = UART_Available() ;
          if (ans != 0) {
               // 1oCgǂݏo
               dt = UART_Read() ;
               // ZeX̊Jn
               if (dt == '$') SentencesNum = 0 ;
               if (SentencesNum >= 0) {
                    // ZeXobt@ɗ߂
                    SentencesData[SentencesNum] = dt ;
                    SentencesNum++ ;
                    // ZeX̍Ō(LF=0x0AŔf)
                    if (dt == 0x0a || SentencesNum >= SENTENCES_BUFLEN) {
                         // ZeX̃Xe[^X"L"ɂȂ܂ő҂
                         if (GPS_Status == 0) GPS_StatusCheck() ;
                         else {
                              // LɂȂ珑݊Jn
                              for (i=0 ; i<7 ; i++) {
                                   // MZeXݑΏۂׂ
                                   if (strncmp((char *)SentencesData,WritingInfo[i].sentencesID,6) == 0 &&
                                       WritingInfo[i].WriteFlag == 1) {
                                        // ފԊu珑
                                        if (i==0) WriteIntervalCount++ ;
                                        if (WriteIntervalCount == WRITE_INTERVAL) {
                                             GPS_WriteMessage() ;  // SD
                                        }
                                        // ފԊũJE^Zbg
                                        if (WriteIntervalCount > WRITE_INTERVAL) {
                                             WriteIntervalCount = 0 ;
                                        }
                                        break ;
                                   }
                              }
                         }
                         SentencesNum = -1 ;
                    }
               }
          }
     }
}
/*******************************************************************************
*  Wait(num)   ԑ҂̏s                                            *
*    num : 10msPʂŎw肷                                                  *
*******************************************************************************/
void Wait(unsigned int num)
{
     int i ;

     // numŎw肵񐔂JԂ
     for (i=0 ; i<num ; i++) {
          __delay_ms(10) ;    // 10msvÖꎞ~
     }
}
/*******************************************************************************
*  GPS_WriteMessage()                                                          *
*    ZeXrcɏޏ                                            *
*    t@C͍쐬AL΃t@C̍Ōɒǉ܂            *
*******************************************************************************/
void GPS_WriteMessage()
{
     struct SDFILE_OBJECT fp ;
     int ans ;

     // t@CVKɍ쐬ăI[v
     ans = SD_Open(&fp,Filename,O_RDWR) ;
     if (ans == 0) {
          // t@C̍ŌɏވʒuʒuÂ
          SD_Seek(&fp,1,4) ;
          // t@C֏
          ans = SD_Write(&fp,SentencesData,SentencesNum) ;
          // t@C̃N[Y
          SD_Close(&fp) ;
     } else {
          // t@C̃I[vG[
          LCD_SetCursor(0,1) ;
          LCD_Puts("FailOpen") ;
     }
}
/*******************************************************************************
*  GPS_StatusCheck()                                                           *
*    GPS̃ZeXLׂ鏈                                         *
*    "$GPRMC"bZ[W2ڂ̕Ŕf܂B                           *
*******************************************************************************/
void GPS_StatusCheck()
{
     char buf[8] ;
     int  ans ;
     
     memset(buf,0x00,sizeof(buf)) ;
     ans = GPS_GetMessageItem(buf,WritingInfo[2].sentencesID,2) ;
     if (ans == 1 && buf[0] == 'A') {
          // t(UTC)t@CɃZbg
          GPS_GetMessageItem(&Filename[1],WritingInfo[2].sentencesID,9) ;
          // M(L)ɂȂɓtł\悤
          memcpy(buf,&Filename[1],6) ;
          LCD_SetCursor(1,0) ;
          LCD_Puts(buf) ;
          // Xe[^X"L"
          GPS_Status = 1 ;
     }
}
/*******************************************************************************
*  ans = GPS_GetMessageItem(*dt1,*dt2,cnt)                                     *
*    GPSMZeX̊eڂo                           *
*    MbZ[W *dt2 ƈv ans=1 Ńp[^o܂B *
*    w肵ʒu(cnt)̃p[^o *dt1 ɓeݒ肵܂B *
*                                                                              *
*    dt1 : oZeX(p[^)̕Ԃ                  *
*          oi[obt@0x00ŏĒuǂł*
*    dt2 : $<vendor:2><message;3>wAႦ"$GPRMC"ł                  *
*    cnt : op[^̈ʒuw肵܂                                *
*          $GPRMC,075453.000,A,*68cnt=2Ȃdt1="A"ƂȂk͕tȂB*
*    ans : w*dt2 ƈvans=1ŕsvȂans=0                       *
*******************************************************************************/
int GPS_GetMessageItem(char *dt1,char *dt2,int cnt)
{
     char *p ;
     int ans , i , j , c ;

     ans = 0 ;
     // MZeX́Aw̃bZ[Wƈvׂ
     if (strncmp((char *)SentencesData,dt2,6) == 0) {
          ans = 1 ;
          c   = 0 ;
          // ZeX̒JԂ
          for (i=0 ; i<SentencesNum ; i++) {
               if (SentencesData[i] == ',') c++ ; // ؂蕶𐔂
               if (c == cnt) {
                    // w肵ꏊ̋؂蕶Ȃ炻̃p[^Rs[
                    p = (char *)dt1 ;
                    for (j=i+1 ; j<SentencesNum ; j++) {
                         if (SentencesData[j]==',' || SentencesData[j]=='*') break ;
                         *p = SentencesData[j] ;
                         p++ ;
                    }
                    break ;
               }
          }
     }
     return ans ;
}
