/*******************************************************************************
*  skSPIlib.c - rohʐMs֐Cu                                 *
*                                                                              *
*    SPI_Init            - roh[h(}X^[)̐ݒƏs      *
*    SPI_setDataMode     - roh̓][hݒs                    *
*    SPI_setClockDivider - roh̒ʐMxݒs                      *
*    SPI_transfer        - rohʐMł̃f[^Mƃf[^Ms      *
*                                                                              *
*    FSDIs͕KufW^̓svɐݒsĉB             *
*          gpSS(CS)s͏HIGHɂ܂B                        *
*          SSP2𗘗pꍇ́AskI2Clib.h"#define SPI_MSSP2_USE"錾 *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2012-04-30  ޒH[(ނ)  Create                            *
*  1.01    2012-12-29  ޒH[(ނ)  XC8 C Compiler ΉɕύX         *
*  1.10    2013-02-18  ޒH[(ނ)  SPI_Init֐ύX                *
*  1.11    2014-06-21  ޒH[(ނ)  SPI_Init֐̃RgύX      *
*  2.00    2014-09-03  ޒH[(ނ)  18F25K22̓mF,ݏ~߂*
*  2.10    2014-09-27  ޒH[(ނ)  SPI_Init֐ύX                *
*  3.00    2015-04-05  ޒH[(ނ)  x/]mode֐ǉ           *
*  3.10    2015-04-20  ޒH[(ނ)  SSP1/SSP216F193xɑΉ      *
*  3.11    2015-05-23  ޒH[(ނ)  16F1825/1829ɑΉ                *
*  3.20    2016-06-14  ޒH[(ނ)  SPI_MODECKE(NbNʑ)ύX *
* ============================================================================ *
*  PIC 12F1822 16F182x 16F193x 18F2xK22                                        *
*  MPLAB IDE(V8.84) MPLAB X(V2.15)                                             *
*  MPLAB(R) XC8 C Compiler Version 1.00/1.32                                   *
*******************************************************************************/
#include <xc.h>
#include "skSPIlib.h"

/*******************************************************************************
*  SPI_Init(mode,divider,sdo)                                                  *
*    roh[h̐ݒƏs                                      *
*    荞݂ł̏~߂Ē"SSP1IF"lɂĂ܂                  *
*                                                                              *
*    mode :   SPI̓][hݒ肵܂(NbNɐƃNbNʑ̑g)  *
*             SPI_MODE1 = ɐ(0:LOW)  ʑ(0:ACh0VŁA0V->5Vɕωœ])*
*             SPI_MODE0 = ɐ(0:LOW)  ʑ(1:ACh0VŁA5V->0Vɕωœ])*
*             SPI_MODE3 = ɐ(1:HIGH) ʑ(0:ACh5VŁA5V->0Vɕωœ])*
*             SPI_MODE2 = ɐ(1:HIGH) ʑ(1:ACh5VŁA0V->5Vɕωœ])*
*    divider :SPI̒ʐMxݒ肵܂                                        *
*             SPI_CLOCK_DIV4   = Fosc/4                                        *
*             SPI_CLOCK_DIV16  = Fosc/16                                       *
*             SPI_CLOCK_DIV64  = Fosc/64                                       *
*             SPI_CLOCK_DIVT2  = TMR2̏o͂1/2                               *
*             SPI_CLOCK_DIVADD = FOSC/((SSPxADD + 1)*4)                        *
*    sdo :    gpSDOM̃sԍw肷                              *
*******************************************************************************/
void SPI_Init(char mode,char divider,int sdo)
{
     char con , stat ;

#if defined(_12F1822)
     SDOSEL = 0 ;                  // 7ԃs(RA0)SDOMsƂ
     if (sdo == 3) SDOSEL = 1 ;    // 3ԃs(RA4)SDOMsƂ
#endif

#if defined(_16F1823) 
     SDOSEL = 0 ;                  // 8ԃs(RC2)SDOMsƂ
     if (sdo == 3) SDOSEL = 1 ;    // 3ԃs(RA4)SDOMsƂ
#endif

#if defined(_16F1825) 
     SDO1SEL = 0 ;                 // 8ԃs(RC2)SDO1MsƂ
     if (sdo == 3) SDO1SEL = 1 ;   // 3ԃs(RA4)SDO1MsƂ
#endif

#if defined(_16F1826) || defined(_16F1827)
     SDO1SEL = 0 ;                 //  8ԃs(RB2)SDO1MsƂ
     if (sdo == 15) SDO1SEL = 1 ;  // 15ԃs(RA6)SDO1MsƂ
#endif

#if defined(_16F1829) 
     SDO2SEL = 0 ;                 // 15ԃs(RC1)SDO2MsƂ
     if (sdo == 2) SDO2SEL = 1 ;   //  2ԃs(RA5)SDO2MsƂ
#endif

     con  = 0b00100000 ;       // NbNɐLOW@}X^[hFOSC/4̃NbNɐݒ
     stat = 0b00000000 ;       // NbNʑ͂O(GbWŃf[^𑗐M)
     con  = con | divider ;    // w̃NbNxݒ肷
     if (mode == SPI_MODE0 || mode == SPI_MODE2) {
          stat = stat | 0x40 ; // w̃NbNʑݒ肷(NbNʑ1Ƃ)
     }
     if (mode == SPI_MODE2 || mode == SPI_MODE3) {
          con = con | 0x10 ;   // w̃NbNɐݒ肷(ɐHIGHƂ)
     }
     SPI_SSPCON1 = con ;
     SPI_SSPSTAT = stat ;
     SPI_SSPIF   = 0 ;         // roh̊݃tO
     PEIE  = 1 ;               // ӑuݗL
     GIE   = 1 ;               // Sݏ
}
/*******************************************************************************
*  SPI_setDataMode(mode)                                                       *
*    roh̓][hݒs                                          *
*    mode :   SPI̓][hݒ肵܂(NbNɐƃNbNʑ̑g)  *
*******************************************************************************/
void SPI_setDataMode(char mode)
{
     if (mode == SPI_MODE0 || mode == SPI_MODE2) {
          SPI_SSPSTAT = SPI_SSPSTAT | 0x40 ; // w̃NbNʑPݒ肷
     } else {
          SPI_SSPSTAT = SPI_SSPSTAT & 0xBF ; // w̃NbNʑOݒ肷
     }
     if (mode == SPI_MODE2 || mode == SPI_MODE3) {
          SPI_SSPCON1 = SPI_SSPCON1 | 0x10 ; // w̃NbNɐHIGHݒ肷
     } else {
          SPI_SSPCON1 = SPI_SSPCON1 & 0xEF ; // w̃NbNɐLOWݒ肷
     }
}
/*******************************************************************************
*  SPI_setClockDivider(divider,rate)                                           *
*    roh̒ʐMxݒs                                            *
*    divider :SPI̒ʐMxݒ肵܂                                        *
*             SPI_CLOCK_DIVADD = FOSC/((SSPxADD + 1)*4)                        *
*    rate    :SSPxADDɐݒ肷l                                              *
*******************************************************************************/
void SPI_setClockDivider(char divider,char rate)
{
     if (divider == SPI_CLOCK_DIVADD) {
          SPI_SSPADD = rate ;
     }
     SPI_SSPCON1 = (SPI_SSPCON1 & 0xF0)  | divider ;    // w̃NbNxݒ肷
}
/*******************************************************************************
*  ans = SPI_transfer(dt)                                                      *
*    rohʐMł̃f[^Mƃf[^Ms                            *
*                                                                              *
*    dt  : Wrbg̑Mf[^w肵܂                                *
*    ans : Wrbg̎Mf[^Ԃ܂                                  *
*******************************************************************************/
unsigned char SPI_transfer(char dt)
{
     SPI_SSPBUF = dt ;            // f[^̑M
     while(SPI_SSPIF == 0) ;      // M҂
     SPI_SSPIF = 0 ;              // tONA
     return SPI_SSPBUF ;          // f[^̎M
}
